function Create(self)
	self.reloadtime = 1000 --1s, the rear tube will take 5 times this time to reload
	self.rte = "Wehrmacht.rte" --the name of this mod's rte

	local sound = CreateMOSRotating("Sub Sound Particle",self.rte );
	sound.Pos = self.Pos;
	MovableMan:AddMO(sound);
			
	self.canfire = 1;
	self.canfirerear = 5;
	self.firetimer = Timer();

	self.Turret = {};
	self.Turret.Team = 0;
	--self.DetectTimer[1] = Timer();
	--self.Turret[1].IsControllable = true;
	--create the turrets.
	self.Turret[1] = CreateACrab("Sub Gun");
	MovableMan:AddParticle(self.Turret[1]);
	self.Turret[1].Offset = Vector(80,-15);
end

function Destroy(self)
	for i = 1, #self.Turret do
		if MovableMan:IsParticle(self.Turret[i]) == true then
			if self.Health < 1 then
				self.Turret[i]:GibThis()
			else
				self.Turret[i].ToDelete = true
			end
		end
	end
end

function Update(self)
	if self:IsPlayerControlled() and UInputMan:KeyHeld(24) then
		self.RotAngle = self.RotAngle - 0.005;
		if self.AngularVel > 30 then
			self.AngularVel = self.AngularVel - 0.1;
		end
		if self.AngularVel < -30 then
			self.AngularVel = self.AngularVel + 0.1;
		end
	end



	if self:IsPlayerControlled() and UInputMan:KeyHeld(26) then
		self.RotAngle = self.RotAngle + 0.005;
		if self.AngularVel > 30 then
			self.AngularVel = self.AngularVel - 0.1;
		end
		if self.AngularVel < -30 then
			self.AngularVel = self.AngularVel + 0.1;
		end
	end
	                                        
	if self.RotAngle > (math.pi/4) and self.HFlipped == false then
		self.RotAngle = -(math.pi/5);
		self.HFlipped = true;
	end
	
	if self.RotAngle < (-math.pi/4) and self.HFlipped == false then
		self.RotAngle = (math.pi/5);
		self.HFlipped = true;
	end
	
	if self.RotAngle < (-math.pi/4) and self.HFlipped == true then
		self.RotAngle = (math.pi/5);
		self.HFlipped = false;
	end
	
	if self.RotAngle > (math.pi/4) and self.HFlipped == true then
		self.RotAngle = -(math.pi/5);
		self.HFlipped = false;
	end	
	

	
	if self:IsPlayerControlled() and UInputMan:MouseButtonPressed(0) and self.canfire == 1 then
		local torpedo = CreateAEmitter("Torpedo",self.rte );
		if self.HFlipped == false then
        	torpedo.Pos = Vector(self.Pos.X+math.cos(self.RotAngle)*210,self.Pos.Y-math.sin(self.RotAngle)*210);
        	torpedo.RotAngle = self.RotAngle;
        end
        if self.HFlipped == true then
        	torpedo.Pos = Vector(self.Pos.X-math.cos(self.RotAngle)*210,self.Pos.Y+math.sin(self.RotAngle)*210);
        	torpedo.RotAngle = self.RotAngle + math.pi;
        end
		MovableMan:AddMO(torpedo);
		
		local sound2 = CreateMOSRotating("Torpedo Sound Particle",self.rte);
		sound2.Pos = self.Pos;
		MovableMan:AddMO(sound2);
		
		self.canfire = 0;
		self.firetimer:Reset();
	end
	
	if self:IsPlayerControlled() and UInputMan:MouseButtonPressed(1) and self.canfirerear == 5 then
		local torpedo = CreateAEmitter("Torpedo",self.rte );
		if self.HFlipped == false then
        	torpedo.Pos = Vector(self.Pos.X-math.cos(self.RotAngle)*210,self.Pos.Y+math.sin(self.RotAngle)*210);
        	torpedo.RotAngle = self.RotAngle + math.pi;
        end
        if self.HFlipped == true then
        	torpedo.Pos = Vector(self.Pos.X+math.cos(self.RotAngle)*210,self.Pos.Y-math.sin(self.RotAngle)*210);
        	torpedo.RotAngle = self.RotAngle;
        end
		MovableMan:AddMO(torpedo);
		
		local sound2 = CreateMOSRotating("Torpedo Sound Particle",self.rte);
		sound2.Pos = self.Pos;
		MovableMan:AddMO(sound2);
		
		self.canfirerear = 0;
		self.firetimer:Reset();
	end
	
	if (self.canfire == 0 or self.canfirerear < 5) and self.firetimer:IsPastSimMS(self.reloadtime) then
		if self.canfire == 0 then
			self.canfire = 1;
		end
		if self.canfirerear < 5 then
			self.canfirerear = self.canfirerear + 1;
		end
		self.firetimer:Reset();

	for i = 1, #self.Turret do
		if MovableMan:IsParticle(self.Turret[i]) == true then
			--basic turret position upkeep (so it doesn't fall at 999999m/s)
			self.Turret[i].Vel.X = 0;
			self.Turret[i].Vel.Y = 0;
			--update turret position
			self.Turret[i].RotAngle = self.RotAngle;
			self.Turret[i].Pos = self.Pos + self:RotateOffset(self.Turret[i].Offset)
		end
	end
end
